---
title: V2.8
description: Version 2.8 release notes
weight: 650
---

# V2.8
Grafana Labs is excited to announce the release of Loki 2.8. Here's a summary of new enhancements and important fixes:

## Features and enhancements

- **TSDB index no longer experimental** After extensive testing of the new TSDB index in our Grafana Cloud Logs offering, we can safely announce that it is no longer experimental and encourage all Loki deployments to use it!
- **Query blocker** Queries can now be blocked in the Querier/Ruler via a per-tenant runtime configuration.
- **New `backend` target** A new, third target was added to Loki's _scalable_ configuration, which is the default configuration used in the Loki helm chart. This allows Loki to be run as 3 targets (`read`, `write`, and `backend`) and makes the `read` target stateless and therefore able to be run as a Kubernetes deployment that can be scaled automatically.


For a full list of all changes, look at the [CHANGELOG](https://github.com/grafana/loki/blob/release-2.8.x/CHANGELOG.md).

## Upgrade Considerations

As always, please read the [upgrade guide](../../setup/upgrade/#270) before upgrading Loki.

## Bug fixes

### 2.8.6 (2023-10-17)

* Upgrade go to v1.20.10, golang.org/x/net to v0.17.0 and grpc-go to v1.56.3 to patch CVE-2023-39325 / CVE-2023-44487

### 2.8.5 (2023-09-14)

* Update Docker base images to mitigate security vulnerability CVE-2022-48174

### 2.8.2 (2023-05-03)

* Update Go to 1.20.4 to address security vulnerabilities in the previous Go version.
* *Promtail*: Add new `decompression` configuration to customize the decompressor behavior.

### 2.8.1 (2023-04-21)

* Fix bug that was dropping index if period is a zero value.
* Fix redis client to prevent it from incorrectly choosing cluster mode with local address.
* Update go to 1.20.3 to address security vulnerabilities in the previous go version.
* Update alpine image to 3.16.5 to address security vulnerabilities in the previous version.
* *Promtail*: Fix journald support in amd64 binary build.


For a full list of all changes and fixes, look at the [CHANGELOG](https://github.com/grafana/loki/blob/release-2.8.x/CHANGELOG.md).
