---
title: Contributing
description: How can I contribute to the Loki Operator?
lead: ""
lastmod: "2021-03-08T08:48:57+00:00"
draft: false
images: []
menu:
  docs:
    parent: prologue
weight: 200
toc: true
---

This project is licensed under the [AGPLv3 license](../../../../../LICENSE) and accept
contributions via GitHub pull requests. This document outlines some of the
conventions on development workflow, contact points
and other resources to make it easier to get your contribution accepted.

To maintain a safe and welcoming community, all participants must adhere to the
project's [Code of Conduct](../../../../../CODE_OF_CONDUCT.md).

# Contributor License Agreement

By contributing to this project you agree to the Contributor License Agreement.

# Email and Chat

The project currently uses the [Grafana Slack](https://grafana.slack.com):
- [#loki-operator-dev](https://grafana.slack.com/archives/C02RFD9CWVA)

## Getting Started

- Fork the repository on GitHub
- Read the [README](README.md) for build and test instructions
- Play with the project, submit bugs, submit patches!

## Contribution Flow

This is a rough outline of what a contributor's workflow looks like:

- Create a topic branch from where you want to base your work (usually `main`).
- Make commits of logical units.
- Make sure your commit messages are in the proper format (see below).
- Push your changes to a topic branch in your fork of the repository.
- Make sure the tests pass, and add any new tests as appropriate.
- Submit a pull request to the original repository.

Thanks for your contributions!
